#!/usr/bin/ruby
#----------------------------------------------------------------------------
#
# Wikiɑ؂Ȃ (SOMEDAY'S WIKERS)
#           -- Network Edition --
#
#    Programed by NAKAUE.T
#
# 2002.12.21 Version 0.1  ͓̓
# 2002.12.24 Version 0.2  ŏ̃lbg[N
#                         r͖
#                         ^Ö댯Ȃ܂
# 2002.01.21 Version 0.3  wwwd.rbƑgݍ킹[J
#
#----------------------------------------------------------------------------
WTTK_VERSION='wttk 0.3'
DEBUG=true
NODBM_MODE=false
$KCODE='s'
#----------------------------------------------------------------------------
require 'jcode'
require 'kconv'
require 'cgi-lib'
require 'gdbm' if !NODBM_MODE
#----------------------------------------------------------------------------
DATA_PATH='/home/groups/w/wt/wttk/cgi-bin'

LOCAL_DATA_PATH=''
LOCAL_EDITOR=nil

DATA_DBM='wikidata.gdbm'

ENGINE_URI='/cgi-bin/wttk.rb'
DOCUMENT_STYLESHEET='/wiki.css'
DOCUMENT_ICON='/wttk.ico'

WIKINAME_INDEX='index'
WIKINAME_WRITEOK='writeok'
WIKINAME_ERROR='error'
WIKINAME_EMPTY='empty'
WIKINAME_HELP='help'

DOCUMENT_FILE=[
	WIKINAME_WRITEOK,
	WIKINAME_ERROR,
	WIKINAME_EMPTY,
	WIKINAME_HELP,
]

DOCUMENT_LANG='ja'
DOCUMENT_CHARSET='Shift_JIS'

PERMIT_URL=[
	Regexp::new('^https?:[^\x00-\x20()<>\x7F-\xFF]+'),
]
#----------------------------------------------------------------------------
$db=nil
#----------------------------------------------------------------------------
def page_exist?(page)
  if DOCUMENT_FILE.include?(page) || NODBM_MODE
    File::file?(page_to_file(page))
  else
    $db.key?(page)
  end
end
#----------------------------------------------------------------------------
def page_to_file(page)
  page=WIKINAME_INDEX if !page
  DATA_PATH+"/"+page+".txt"	#댯
end
#----------------------------------------------------------------------------
def page_to_localfile(page)
  page=WIKINAME_INDEX if !page
  LOCAL_DATA_PATH+"/"+page+".txt"	#댯
end
#----------------------------------------------------------------------------
def output_header(title)
  return "Content-type: text/html; charset=#{DOCUMENT_CHARSET}\r\n\r\n"+
         '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">'+"\r\n"+ <<"EOD"
<html lang="#{DOCUMENT_LANG}">
<head>
  <meta http-equiv="Content-Language" content="#{DOCUMENT_LANG}" />
  <meta http-equiv="Content-Type" content="text/html; charset=#{DOCUMENT_CHARSET}" />
  <link rel="index" href="#{ENGINE_URI}?#{WIKINAME_INDEX}" />
  <link rel="stylesheet" type="text/css" href="#{DOCUMENT_STYLESHEET}" />
  <link rel="shortcut icon" type="image/x-icon" href="#{DOCUMENT_ICON}" />
  <title>#{title}</title>
</head>
<body>
<div class="header">
 <a href="#{ENGINE_URI}?#{WIKINAME_INDEX}">Index</a>
|<a href="#{ENGINE_URI}?edit=#{CGI::escape(title)}">Edit</a>
#{"|<a href='#{ENGINE_URI}?localedit=#{CGI::escape(title)}'>Edit(local)</a>" if LOCAL_EDITOR}
|<a href="#{ENGINE_URI}?#{WIKINAME_HELP}">Help</a>
</div>
<h1 class="title">#{title}</h1>
EOD

end
#----------------------------------------------------------------------------
def output_footer
  return <<"EOD"
<div class="footer">
  #{WTTK_VERSION} #{if NODBM_MODE;"(local mode)";else;"(network mode)";end} by Meister@SSR
<a href="http://sourceforge.jp"><img src="http://sourceforge.jp/sflogo.php?group_id=426" width="96" height="31" border="0" alt="SourceForge.jp"></a>
</div>
</body>
</html>
EOD

end
#----------------------------------------------------------------------------
def parse0(src)
#  src.gsub!(/^$/,"[br]")	# ƃ_T
  return parse1(src)
end
#----------------------------------------------------------------------------
def parse1(src)
  parsed=""

  while pos=(src=~/[[\]]/)
    delim=$&
    parsed+=parse4(src.slice(0..pos-1)) if pos>0
    src.slice!(0..pos)

    break if delim===']'

    src.sub!(/^ */,"")

    if src.size>0
      if src[0]=='['[0]
        src.slice!(0..0)
        buff,src=parse2(src)
        parsed+=buff
      else
        buff,src=parse3(src)
        parsed+=buff
      end
    end
  end

  return parsed,src
end
#----------------------------------------------------------------------------
def parse2(src)
  parsed=""

  if pos=src.index(']')
    pos2=src.index(']',pos+1)
    pos2=pos if !pos2
    str1=src.slice(0..pos-1)
    str2=src.slice(pos+1..pos2-1)
    src.slice!(0..pos2)

    if pos!=pos2
      scheme=""
      if str1=~/:/
        str1=~/^([^:]*):(.*)$/
        scheme=$1
        wikiname=$2
      else
        str1=~/^(.*)$/
        wikiname=$1
      end

      linkstr=wikiname
      linkstr=$1 if str2=~/^ *([^ ]+) */

      if wikiname
        if scheme.size==0
          if page_exist?(wikiname)
            parsed="<a class='wikiname' href='#{ENGINE_URI}?"+CGI::escape(wikiname)+"'>#{linkstr}</a>"
          else
            parsed="#{linkstr}<a class='wikiname_notexist' href='#{ENGINE_URI}?"+CGI::escape(wikiname)+"'>?</a>"
          end
        else
          case scheme
          when 'file'
            wikiname.gsub!(/\\/,'/')
            parsed="<a class='wikiname' href='#{ENGINE_URI}?localfile="+CGI::escape(wikiname)+"'>#{linkstr}</a>"
#            parsed="<a class='wikiname' href='file:///"+wikiname+"'>#{linkstr}</a>"
          end
        end
      end
    else
      #error
    end
  else
    # error
  end

  return parsed,src
end
#----------------------------------------------------------------------------
def parse3(src)
  parsed=""

  if src.size>0
    tag=""
    attr=[]
    if src[0]=='('[0]
      src=~/^\( *([^)]*) *\) */
      tag2=$1
      src=$'
      tag2=~/^([A-Za-z][A-Za-z0-9]*) */
      tag=$1
      attr=$'.split(' ')		# R
    else
      src=~/^([A-Za-z][A-Za-z0-9]*) */
      tag=$1
      src=$'
    end

    buff,src=parse1(src)

    case tag
    when 'h','h1'
      parsed="<h2>#{buff}</h2>"
    when 'h2'
      parsed="<h3>#{buff}</h3>"
    when 'h3'
      parsed="<h4>#{buff}</h4>"
    when 'p'
      parsed="<p>#{buff}</p>"
    when 'pre'
      parsed="<tt><pre>#{buff}</pre></tt>"
    when 'comment'
      parsed="<div class='comment'>#{buff}</div>"
    when 'center'
      parsed="<div align='center'>#{buff}</div>"
    when 'right'
      parsed="<div align='right'>#{buff}</div>"
    when 'sub'
      parsed="<sub>#{buff}</sub>"
    when 'sup'
      parsed="<sup>#{buff}</sup>"
    when 'b'
      parsed="<strong><b>#{buff}</b></strong>"
    when 'i'
      parsed="<em><i>#{buff}</i></em>"
    when 'hr'
      parsed="<hr />"
    when 'br'
      parsed="<br />"
    when 'inline'
      if attr[0]	# R
        parsed,dummy=parse1(read_page(attr[0],nil)+"]")	# 댯
      end
    when 'img'
      if attr[0]
        url=attr[0]	# R
        parsed="<span class='link'>#{url}</span>"
        PERMIT_URL.each {|pat|
          parsed="<img src='#{url}' alt='#{url}' />" if url =~ pat
        }
      end
    when 'bbs'
      if attr[0]	# R
        parsed,dummy=parse1(read_page(attr[0],nil)+"]")	# 댯
        parsed+="<br /><a href='#{ENGINE_URI}?bbs=#{CGI::escape(attr[0])}'>#{attr[0]}</a>"
      end
    when 'ul'	# b
      parsed="<ul>#{buff}</ul>"
    when 'li'	# b
      parsed="<li>#{buff}</li>"
    else
      #error
    end
  end

  return parsed,src
end
#----------------------------------------------------------------------------
def parse4(src)
  parsed=parse5(src)

  parsed.gsub!(Regexp.new('https?:[^\x00-\x20()<>\x7F-\xFF]+')) {
    url=$&
    parsedurl="<span class='link'>#{url}</span>"
    PERMIT_URL.each {|pat|
      parsedurl="<a href='#{url}'>#{url}</a>" if url =~ pat
    }
    parsedurl
  }

  return parsed
end
#----------------------------------------------------------------------------
def parse5(src)
  parsed=src

  parsed.gsub!(/&([^#])/) {'&amp;'+$1}
  parsed.gsub!(/</,'&lt;')
  parsed.gsub!(/>/,'&gt;')
  parsed.gsub!(/"/,'&quot;')

  return parsed
end
#----------------------------------------------------------------------------
def read_page(page,faultpage)
  src=""

  if faultpage
    faultpage=nil if !page_exist?(faultpage)
  end

  if DOCUMENT_FILE.include?(page) || NODBM_MODE
    begin
      fp=open(page_to_file(page))
      src=fp.read.gsub("\r","")
      fp.close
    rescue
      if faultpage
        fp=open(page_to_file(faultpage))
        src=fp.read.gsub("\r","")
        fp.close
      end
    end
  else
    if $db.key?(page)
      src=$db[page]
    else
      if faultpage
        fp=open(page_to_file(faultpage))
        src=fp.read.gsub("\r","")
        fp.close
      end
    end
  end

  return src
end
#----------------------------------------------------------------------------
def output_page(page)
  return output_header(page)+output_page2(page)+output_footer
end
#----------------------------------------------------------------------------
def output_page2(page)
  parsed,dummy=parse0(read_page(page,WIKINAME_EMPTY)+"]")
  return parsed
end
#----------------------------------------------------------------------------
def edit_page(page)
  src=parse5(read_page(page,nil))
  src.gsub!(/&#/,'&amp;#')

  output=output_header(page)+ <<"EOD"
<form action="#{ENGINE_URI}" method="POST">
<input type="hidden" name="writepage" value="#{CGI::escape(page)}" />
<textarea name="data" cols="80" rows="30" wrap="off">#{src}</textarea><br />
<input type="submit" value="ۑ" />
</form>
EOD
  output=output+output_footer
#  output=output+output_page2(WIKINAME_HELP)+output_footer

  return output
end
#----------------------------------------------------------------------------
def write_page(page,data)
  output=output_header(page)

  if DOCUMENT_FILE.include?(page) || NODBM_MODE
    begin
      fp=open(page_to_file(page),"w")
      fp.write(data.gsub("\r",""))
      fp.close()
      output=output+output_page2(WIKINAME_WRITEOK)
    rescue
      output=output+output_page2(WIKINAME_ERROR)
    end
  else
    $db[page]=data
    output=output+output_page2(WIKINAME_WRITEOK)
  end

  parsed,dummy=parse0("[[#{page}]]"+"]")
  output=output+parsed+output_footer()
end
#----------------------------------------------------------------------------
def localfile_page(path)
  output="Content-type: text/plain\r\n\r\nok.\r\n"

  if File::file?(path)
    system('ShellExecute',path)	# Windowsp
  elsif File::directory?(path)
    path=path+"/" if (/\/$/=~path)==nil
    src="[[file:"+path.sub(/\/[^\/]+\/$/,"")+"]..][br]"
    Dir::foreach(path) {|f|
      if (/^\./ =~ f) == nil
        ff=path+f
        if File::directory?(ff)
          src=src+"[[file:"+ff+"/]"+f+"/]"+"[br]\n" 
        else
          src=src+"[[file:"+ff+"]"+f+"]"+"[br]\n" 
        end
      end
    }

    parsed,dummy=parse0(src+"]")

    output=output_header(path)+parsed+output_footer()
  else
    output="Content-type: text/plain\r\n\r\n#{path} not found.\r\n"
  end

  return output
end
#----------------------------------------------------------------------------
def process
  output=""
  $db=GDBM.open(DATA_PATH+"/"+DATA_DBM) if !NODBM_MODE

  if (ENV['REQUEST_METHOD']==='GET') && (ENV['QUERY_STRING'] !~ /=/)
    page=WIKINAME_INDEX
    page=CGI::unescape(ENV['QUERY_STRING']) if ENV['QUERY_STRING']
    output=output_page(page)
  else
    if ENV["POST_TEXT"]		# wwwd.rb΍
      ENV['REQUEST_METHOD']="GET"
      ENV['QUERY_STRING']=ENV["POST_TEXT"]
    end
    cgi=CGI.new
    if cgi.key?('edit')
      output=edit_page(CGI::unescape(cgi['edit']))
    elsif cgi.key?('writepage') && cgi.key?('data')
      output=write_page(CGI::unescape(cgi['writepage']),CGI::unescape(cgi['data']))
=begin
    elsif cgi.key?('localedit')
      page=page_to_localfile(CGI::unescape(cgi['localedit']))
      system('ShellExecute',LOCAL_EDITOR,page)	# Windowsp
      output="Content-type: text/plain\r\n\r\nok\r\n"
    elsif cgi.key?('localfile')
      output=localfile_page(CGI::unescape(cgi['localfile']))
=end
    else
      output=output_page(WIKINAME_ERROR)
    end
  end

  return output
end
#----------------------------------------------------------------------------
print process()
